Loading...
Searching...
No Matches
juce::CharPointer_UTF8 Class Referencefinal

## Detailed Description

Wraps a pointer to a null-terminated UTF-8 character string, and provides various methods to operate on the data.

See also
  CharPointer_UTF16, CharPointer_UTF32

The documentation for this class was generated from the following file:

- juce_core/text/juce_CharPointer_UTF8.h

## Public Types

enum | { byteOrderMark1 = 0xef , byteOrderMark2 = 0xbb , byteOrderMark3 = 0xbf }
| These values are the byte-order mark (BOM) values for a UTF-8 stream. More...
using | CharType = char

## Public Member Functions

| CharPointer_UTF8 (const CharType *rawPointer) noexcept
| CharPointer_UTF8 (const CharPointer_UTF8 &other)=default
CharPointer_UTF8 & | operator= (const CharPointer_UTF8 &other) noexcept=default
CharPointer_UTF8 & | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_UTF8 other) const noexcept
| This is a pointer comparison, it doesn't compare the actual text.
bool | operator!= (CharPointer_UTF8 other) const noexcept
bool | operator<= (CharPointer_UTF8 other) const noexcept
bool | operator< (CharPointer_UTF8 other) const noexcept
bool | operator>= (CharPointer_UTF8 other) const noexcept
bool | operator> (CharPointer_UTF8 other) const noexcept
CharType * | getAddress () const noexcept
| Returns the address that this pointer is pointing to.
| operator const CharType * () const noexcept
| Returns the address that this pointer is pointing to.
bool | isEmpty () const noexcept
| Returns true if this pointer is pointing to a null character.
bool | isNotEmpty () const noexcept
| Returns true if this pointer is not pointing to a null character.
juce_wchar | operator* () const noexcept
| Returns the unicode character that this pointer is pointing to.
CharPointer_UTF8 & | operator++ () noexcept
| Moves this pointer along to the next character in the string.
CharPointer_UTF8 & | operator-- () noexcept
| Moves this pointer back to the previous character in the string.
juce_wchar | getAndAdvance () noexcept
| Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.
CharPointer_UTF8 | operator++ (int) noexcept
| Moves this pointer along to the next character in the string.
CharPointer_UTF8 & | operator+= (int numToSkip) noexcept
| Moves this pointer forwards by the specified number of characters.
CharPointer_UTF8 & | operator-= (int numToSkip) noexcept
| Moves this pointer backwards by the specified number of characters.
juce_wchar | operator[] (int characterIndex) const noexcept
| Returns the character at a given character index from the start of the string.
CharPointer_UTF8 | operator+ (int numToSkip) const noexcept
| Returns a pointer which is moved forwards from this one by the specified number of characters.
CharPointer_UTF8 | operator- (int numToSkip) const noexcept
| Returns a pointer which is moved backwards from this one by the specified number of characters.
size_t | length () const noexcept
| Returns the number of characters in this string.
size_t | lengthUpTo (const size_t maxCharsToCount) const noexcept
| Returns the number of characters in this string, or the given value, whichever is lower.
size_t | lengthUpTo (const CharPointer_UTF8 end) const noexcept
| Returns the number of characters in this string, or up to the given end pointer, whichever is lower.
size_t | sizeInBytes () const noexcept
| Returns the number of bytes that are used to represent this string.
CharPointer_UTF8 | findTerminatingNull () const noexcept
| Returns a pointer to the null character that terminates this string.
void | write (const juce_wchar charToWrite) noexcept
| Writes a unicode character to this string, and advances this pointer to point to the next position.
void | writeNull () const noexcept
| Writes a null character to this string (leaving the pointer's position unchanged).
template<typename CharPointer>
void | writeAll (const CharPointer src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
void | writeAll (const CharPointer_UTF8 src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer>
size_t | writeWithDestByteLimit (const CharPointer src, const size_t maxDestBytes) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer>
void | writeWithCharLimit (const CharPointer src, const int maxChars) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer>
int | compare (const CharPointer other) const noexcept
| Compares this string with another one.
template<typename CharPointer>
int | compareUpTo (const CharPointer other, const int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer>
int | compareIgnoreCase (const CharPointer other) const noexcept
| Compares this string with another one.
int | compareIgnoreCase (const CharPointer_UTF8 other) const noexcept
| Compares this string with another one.
template<typename CharPointer>
int | compareIgnoreCaseUpTo (const CharPointer other, const int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer>
int | indexOf (const CharPointer stringToFind) const noexcept
| Returns the character index of a substring, or -1 if it isn't found.
int | indexOf (const juce_wchar charToFind) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
int | indexOf (const juce_wchar charToFind, const bool ignoreCase) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
bool | isWhitespace () const noexcept
| Returns true if the first character of this string is whitespace.
bool | isDigit () const noexcept
| Returns true if the first character of this string is a digit.
bool | isLetter () const noexcept
| Returns true if the first character of this string is a letter.
bool | isLetterOrDigit () const noexcept
| Returns true if the first character of this string is a letter or digit.
bool | isUpperCase () const noexcept
| Returns true if the first character of this string is upper-case.
bool | isLowerCase () const noexcept
| Returns true if the first character of this string is lower-case.
juce_wchar | toUpperCase () const noexcept
| Returns an upper-case version of the first character of this string.
juce_wchar | toLowerCase () const noexcept
| Returns a lower-case version of the first character of this string.
int | getIntValue32 () const noexcept
| Parses this string as a 32-bit integer.
int64 | getIntValue64 () const noexcept
| Parses this string as a 64-bit integer.
double | getDoubleValue () const noexcept
| Parses this string as a floating point double.
CharPointer_UTF8 | findEndOfWhitespace () const noexcept
| Returns the first non-whitespace character in the string.
void | incrementToEndOfWhitespace () noexcept
| Move this pointer to the first non-whitespace character in the string.
CharPointer_UTF8 | atomicSwap (const CharPointer_UTF8 newValue)
| Atomically swaps this pointer for a new value, returning the previous value.

## Static Public Member Functions

static size_t | getBytesRequiredFor (const juce_wchar charToWrite) noexcept
| Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.
template<class CharPointer>
static size_t | getBytesRequiredFor (CharPointer text) noexcept
| Returns the number of bytes that would be needed to represent the given string in this encoding format.
static bool | canRepresent (juce_wchar character) noexcept
| Returns true if the given unicode character can be represented in this encoding.
static bool | isValidString (const CharType *codeUnits, int maxBytesToRead)
| Returns true if this data contains a valid string in this encoding.
static bool | isByteOrderMark (const void *possibleByteOrder) noexcept
| Returns true if the first three bytes in this pointer are the UTF8 byte-order mark (BOM).

## Member Typedef Documentation

## CharType

using juce::CharPointer_UTF8::CharType = char

## Member Enums

## anonymous enum

anonymous enum

These values are the byte-order mark (BOM) values for a UTF-8 stream.

Enumerator
byteOrderMark1 |
byteOrderMark2 |
byteOrderMark3 |

## Constructors and Destructors

## CharPointer_UTF8() [1/2]

juce::CharPointer_UTF8::CharPointer_UTF8 | ( | const CharType * | rawPointer | ) |

inline explicit noexcept

Referenced by atomicSwap(), CharPointer_UTF8(), compareIgnoreCase(), findEndOfWhitespace(), findTerminatingNull(), lengthUpTo(), operator!=(), operator+(), operator++(), operator++(), operator+=(), operator-(), operator--(), operator-=(), operator<(), operator<=(), operator=(), operator=(), operator==(), operator>(), operator>=(), and writeAll().

## CharPointer_UTF8() [2/2]

juce::CharPointer_UTF8::CharPointer_UTF8 | ( | const CharPointer_UTF8 & | other | ) |

default

References CharPointer_UTF8().

## Member Functions

## operator=() [1/2]

CharPointer_UTF8 & juce::CharPointer_UTF8::operator= | ( | const CharPointer_UTF8 & | other | ) |

default noexcept

References CharPointer_UTF8().

## operator=() [2/2]

CharPointer_UTF8 & juce::CharPointer_UTF8::operator= | ( | const CharType * | text | ) |

inline noexcept

References CharPointer_UTF8().

## operator==()

bool juce::CharPointer_UTF8::operator== | ( | CharPointer_UTF8 | other | ) | const

inline noexcept

This is a pointer comparison, it doesn't compare the actual text.

References CharPointer_UTF8().

## operator!=()

bool juce::CharPointer_UTF8::operator!= | ( | CharPointer_UTF8 | other | ) | const

inline noexcept

References CharPointer_UTF8().

## operator<=()

bool juce::CharPointer_UTF8::operator<= | ( | CharPointer_UTF8 | other | ) | const

inline noexcept

References CharPointer_UTF8().

## operator<()

bool juce::CharPointer_UTF8::operator< | ( | CharPointer_UTF8 | other | ) | const

inline noexcept

References CharPointer_UTF8().

## operator>=()

bool juce::CharPointer_UTF8::operator>= | ( | CharPointer_UTF8 | other | ) | const

inline noexcept

References CharPointer_UTF8().

## operator>()

bool juce::CharPointer_UTF8::operator> | ( | CharPointer_UTF8 | other | ) | const

inline noexcept

References CharPointer_UTF8().

## getAddress()

CharType * juce::CharPointer_UTF8::getAddress | ( |  | ) | const

inline noexcept

Returns the address that this pointer is pointing to.

## operator const CharType *()

juce::CharPointer_UTF8::operator const CharType * | ( |  | ) | const

inline noexcept

Returns the address that this pointer is pointing to.

## isEmpty()

bool juce::CharPointer_UTF8::isEmpty | ( |  | ) | const

inline noexcept

Returns true if this pointer is pointing to a null character.

## isNotEmpty()

bool juce::CharPointer_UTF8::isNotEmpty | ( |  | ) | const

inline noexcept

Returns true if this pointer is not pointing to a null character.

## operator*()

juce_wchar juce::CharPointer_UTF8::operator* | ( |  | ) | const

inline noexcept

Returns the unicode character that this pointer is pointing to.

## operator++() [1/2]

CharPointer_UTF8 & juce::CharPointer_UTF8::operator++ | ( |  | ) |

inline noexcept

Moves this pointer along to the next character in the string.

References CharPointer_UTF8(), and jassert.

## operator--()

CharPointer_UTF8 & juce::CharPointer_UTF8::operator-- | ( |  | ) |

inline noexcept

Moves this pointer back to the previous character in the string.

References CharPointer_UTF8().

## getAndAdvance()

juce_wchar juce::CharPointer_UTF8::getAndAdvance | ( |  | ) |

inline noexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

## operator++() [2/2]

CharPointer_UTF8 juce::CharPointer_UTF8::operator++ | ( | int |  | ) |

inline noexcept

Moves this pointer along to the next character in the string.

References CharPointer_UTF8().

## operator+=()

CharPointer_UTF8 & juce::CharPointer_UTF8::operator+= | ( | int | numToSkip | ) |

inline noexcept

Moves this pointer forwards by the specified number of characters.

References CharPointer_UTF8().

Referenced by operator-=().

## operator-=()

CharPointer_UTF8 & juce::CharPointer_UTF8::operator-= | ( | int | numToSkip | ) |

inline noexcept

Moves this pointer backwards by the specified number of characters.

References CharPointer_UTF8(), and operator+=().

## operator[]()

juce_wchar juce::CharPointer_UTF8::operator[] | ( | int | characterIndex | ) | const

inline noexcept

Returns the character at a given character index from the start of the string.

## operator+()

CharPointer_UTF8 juce::CharPointer_UTF8::operator+ | ( | int | numToSkip | ) | const

inline noexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

References CharPointer_UTF8().

## operator-()

CharPointer_UTF8 juce::CharPointer_UTF8::operator- | ( | int | numToSkip | ) | const

inline noexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

References CharPointer_UTF8().

## length()

size_t juce::CharPointer_UTF8::length | ( |  | ) | const

inline noexcept

Returns the number of characters in this string.

## lengthUpTo() [1/2]

size_t juce::CharPointer_UTF8::lengthUpTo | ( | const size_t | maxCharsToCount | ) | const

inline noexcept

Returns the number of characters in this string, or the given value, whichever is lower.

References juce::CharacterFunctions::lengthUpTo().

## lengthUpTo() [2/2]

size_t juce::CharPointer_UTF8::lengthUpTo | ( | const CharPointer_UTF8 | end | ) | const

inline noexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

References CharPointer_UTF8(), juce::end(), and juce::CharacterFunctions::lengthUpTo().

## sizeInBytes()

size_t juce::CharPointer_UTF8::sizeInBytes | ( |  | ) | const

inline noexcept

Returns the number of bytes that are used to represent this string.

This includes the terminating null character.

References jassert, JUCE_BEGIN_IGNORE_WARNINGS_MSVC, and JUCE_END_IGNORE_WARNINGS_MSVC.

## getBytesRequiredFor() [1/2]

size_t juce::CharPointer_UTF8::getBytesRequiredFor | ( | const juce_wchar | charToWrite | ) |

inline static noexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

Referenced by juce::String::appendCharPointer(), juce::String::appendCharPointer(), and getBytesRequiredFor().

## getBytesRequiredFor() [2/2]

template<class CharPointer>

size_t juce::CharPointer_UTF8::getBytesRequiredFor | ( | CharPointer | text | ) |

inline static noexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format.

The value returned does NOT include the terminating null character.

References getBytesRequiredFor().

## findTerminatingNull()

CharPointer_UTF8 juce::CharPointer_UTF8::findTerminatingNull | ( |  | ) | const

inline noexcept

Returns a pointer to the null character that terminates this string.

References CharPointer_UTF8().

## write()

void juce::CharPointer_UTF8::write | ( | const juce_wchar | charToWrite | ) |

inline noexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

Referenced by juce::CppTokeniserFunctions::parseIdentifier().

## writeNull()

void juce::CharPointer_UTF8::writeNull | ( |  | ) | const

inline noexcept

Writes a null character to this string (leaving the pointer's position unchanged).

Referenced by juce::CppTokeniserFunctions::parseIdentifier().

## writeAll() [1/2]

template<typename CharPointer>

void juce::CharPointer_UTF8::writeAll | ( | const CharPointer | src | ) |

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

References juce::CharacterFunctions::copyAll().

## writeAll() [2/2]

void juce::CharPointer_UTF8::writeAll | ( | const CharPointer_UTF8 | src | ) |

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

References CharPointer_UTF8().

## writeWithDestByteLimit()

template<typename CharPointer>

size_t juce::CharPointer_UTF8::writeWithDestByteLimit | ( | const CharPointer | src,
|  | const size_t | maxDestBytes )

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

References juce::CharacterFunctions::copyWithDestByteLimit().

## writeWithCharLimit()

template<typename CharPointer>

void juce::CharPointer_UTF8::writeWithCharLimit | ( | const CharPointer | src,
|  | const int | maxChars )

inline noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

References juce::CharacterFunctions::copyWithCharLimit().

## compare()

template<typename CharPointer>

int juce::CharPointer_UTF8::compare | ( | const CharPointer | other | ) | const

inline noexcept

Compares this string with another one.

References juce::CharacterFunctions::compare().

## compareUpTo()

template<typename CharPointer>

int juce::CharPointer_UTF8::compareUpTo | ( | const CharPointer | other,
|  | const int | maxChars ) const

inline noexcept

Compares this string with another one, up to a specified number of characters.

References juce::CharacterFunctions::compareUpTo().

## compareIgnoreCase() [1/2]

template<typename CharPointer>

int juce::CharPointer_UTF8::compareIgnoreCase | ( | const CharPointer | other | ) | const

inline noexcept

Compares this string with another one.

References juce::CharacterFunctions::compareIgnoreCase().

## compareIgnoreCase() [2/2]

int juce::CharPointer_UTF8::compareIgnoreCase | ( | const CharPointer_UTF8 | other | ) | const

inline noexcept

Compares this string with another one.

References CharPointer_UTF8(), and juce::CharacterFunctions::compareIgnoreCase().

## compareIgnoreCaseUpTo()

template<typename CharPointer>

int juce::CharPointer_UTF8::compareIgnoreCaseUpTo | ( | const CharPointer | other,
|  | const int | maxChars ) const

inline noexcept

Compares this string with another one, up to a specified number of characters.

References juce::CharacterFunctions::compareIgnoreCaseUpTo().

## indexOf() [1/3]

template<typename CharPointer>

int juce::CharPointer_UTF8::indexOf | ( | const CharPointer | stringToFind | ) | const

inline noexcept

Returns the character index of a substring, or -1 if it isn't found.

References juce::CharacterFunctions::indexOf().

## indexOf() [2/3]

int juce::CharPointer_UTF8::indexOf | ( | const juce_wchar | charToFind | ) | const

inline noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

References juce::CharacterFunctions::indexOfChar().

## indexOf() [3/3]

int juce::CharPointer_UTF8::indexOf | ( | const juce_wchar | charToFind,
|  | const bool | ignoreCase ) const

inline noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

References juce::CharacterFunctions::indexOfChar(), and juce::CharacterFunctions::indexOfCharIgnoreCase().

## isWhitespace()

bool juce::CharPointer_UTF8::isWhitespace | ( |  | ) | const

inline noexcept

Returns true if the first character of this string is whitespace.

References juce::CharacterFunctions::isWhitespace().

## isDigit()

bool juce::CharPointer_UTF8::isDigit | ( |  | ) | const

inline noexcept

Returns true if the first character of this string is a digit.

## isLetter()

bool juce::CharPointer_UTF8::isLetter | ( |  | ) | const

inline noexcept

Returns true if the first character of this string is a letter.

References juce::CharacterFunctions::isLetter().

## isLetterOrDigit()

bool juce::CharPointer_UTF8::isLetterOrDigit | ( |  | ) | const

inline noexcept

Returns true if the first character of this string is a letter or digit.

References juce::CharacterFunctions::isLetterOrDigit().

## isUpperCase()

bool juce::CharPointer_UTF8::isUpperCase | ( |  | ) | const

inline noexcept

Returns true if the first character of this string is upper-case.

References juce::CharacterFunctions::isUpperCase().

## isLowerCase()

bool juce::CharPointer_UTF8::isLowerCase | ( |  | ) | const

inline noexcept

Returns true if the first character of this string is lower-case.

References juce::CharacterFunctions::isLowerCase().

## toUpperCase()

juce_wchar juce::CharPointer_UTF8::toUpperCase | ( |  | ) | const

inline noexcept

Returns an upper-case version of the first character of this string.

References juce::CharacterFunctions::toUpperCase().

## toLowerCase()

juce_wchar juce::CharPointer_UTF8::toLowerCase | ( |  | ) | const

inline noexcept

Returns a lower-case version of the first character of this string.

References juce::CharacterFunctions::toLowerCase().

## getIntValue32()

int juce::CharPointer_UTF8::getIntValue32 | ( |  | ) | const

inline noexcept

Parses this string as a 32-bit integer.

## getIntValue64()

int64 juce::CharPointer_UTF8::getIntValue64 | ( |  | ) | const

inline noexcept

Parses this string as a 64-bit integer.

## getDoubleValue()

double juce::CharPointer_UTF8::getDoubleValue | ( |  | ) | const

inline noexcept

Parses this string as a floating point double.

References juce::CharacterFunctions::getDoubleValue().

## findEndOfWhitespace()

CharPointer_UTF8 juce::CharPointer_UTF8::findEndOfWhitespace | ( |  | ) | const

inline noexcept

Returns the first non-whitespace character in the string.

References CharPointer_UTF8(), and juce::CharacterFunctions::findEndOfWhitespace().

Referenced by juce::Rectangle< ValueType >::fromString().

## incrementToEndOfWhitespace()

void juce::CharPointer_UTF8::incrementToEndOfWhitespace | ( |  | ) |

inline noexcept

Move this pointer to the first non-whitespace character in the string.

References juce::CharacterFunctions::incrementToEndOfWhitespace().

## canRepresent()

bool juce::CharPointer_UTF8::canRepresent | ( | juce_wchar | character | ) |

inline static noexcept

Returns true if the given unicode character can be represented in this encoding.

References juce::CharacterFunctions::isNonSurrogateCodePoint().

## isValidString()

bool juce::CharPointer_UTF8::isValidString | ( | const CharType * | codeUnits,
|  | int | maxBytesToRead )

inline static

Returns true if this data contains a valid string in this encoding.

References juce::CharacterFunctions::isAscii().

## atomicSwap()

CharPointer_UTF8 juce::CharPointer_UTF8::atomicSwap | ( | const CharPointer_UTF8 | newValue | ) |

inline

Atomically swaps this pointer for a new value, returning the previous value.

References CharPointer_UTF8().

## isByteOrderMark()

bool juce::CharPointer_UTF8::isByteOrderMark | ( | const void * | possibleByteOrder | ) |

inline static noexcept

Returns true if the first three bytes in this pointer are the UTF8 byte-order mark (BOM).

The pointer must not be null, and must point to at least 3 valid bytes.

References byteOrderMark1, byteOrderMark2, byteOrderMark3, jassert, JUCE_BEGIN_IGNORE_WARNINGS_MSVC, and JUCE_END_IGNORE_WARNINGS_MSVC.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited